#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;

#endregion



#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		
		private SniperIndicators.SniperBand[] cacheSniperBand;
		private SniperIndicators.SniperDivergenceOBOS[] cacheSniperDivergenceOBOS;
		private SniperIndicators.SniperEMABand[] cacheSniperEMABand;
		private SniperIndicators.SniperExplosion[] cacheSniperExplosion;
		private SniperIndicators.SniperMultipleLevel[] cacheSniperMultipleLevel;
		private SniperIndicators.SniperSuperTrend[] cacheSniperSuperTrend;
		private SniperIndicators.SniperTrend[] cacheSniperTrend;
		private SniperIndicators.SniperVAD[] cacheSniperVAD;
		private SniperIndicators.SniperVol[] cacheSniperVol;
		private SniperIndicators.SniperVolatility[] cacheSniperVolatility;
		private VWAP81978[] cacheVWAP81978;
		private MACrossBuilder1978[] cacheMACrossBuilder1978;
		private MovingAverageRibbon_Color1978[] cacheMovingAverageRibbon_Color1978;
		private Wilder1978[] cacheWilder1978;
		private LinRegSlopeSFX1978[] cacheLinRegSlopeSFX1978;
		private EMASlopeColor[] cacheEMASlopeColor;

		
		public SniperIndicators.SniperBand SniperBand(CDMAtype2 ma0Type, PriceType fastPriceType, int fastMAPeriod, CDMAtype2 ma1Type, PriceType slowPriceType, int slowMAPeriod, int crossLookBack, bool showCrossAbove, bool showCrossBelow)
		{
			return SniperBand(Input, ma0Type, fastPriceType, fastMAPeriod, ma1Type, slowPriceType, slowMAPeriod, crossLookBack, showCrossAbove, showCrossBelow);
		}

		public SniperIndicators.SniperDivergenceOBOS SniperDivergenceOBOS()
		{
			return SniperDivergenceOBOS(Input);
		}

		public SniperIndicators.SniperEMABand SniperEMABand(bool eMASmall, bool eMABig)
		{
			return SniperEMABand(Input, eMASmall, eMABig);
		}

		public SniperIndicators.SniperExplosion SniperExplosion(int fastma, int slowma)
		{
			return SniperExplosion(Input, fastma, slowma);
		}

		public SniperIndicators.SniperMultipleLevel SniperMultipleLevel(Brush premarketRegionColor, int premarketRegionOpacity, Brush initialBalanceRegionColor, int initialBalanceRegionOpacity)
		{
			return SniperMultipleLevel(Input, premarketRegionColor, premarketRegionOpacity, initialBalanceRegionColor, initialBalanceRegionOpacity);
		}

		public SniperIndicators.SniperSuperTrend SniperSuperTrend(Brush fiveTenLong, Brush fiveTenShort, Brush currentRainbowShort, Brush currentRainbowLong, Brush allThreeLong, Brush allThreeShort)
		{
			return SniperSuperTrend(Input, fiveTenLong, fiveTenShort, currentRainbowShort, currentRainbowLong, allThreeLong, allThreeShort);
		}

		public SniperIndicators.SniperTrend SniperTrend(int wMAHighValue, int wMALowValue, Brush dotColorBarandCloud, Brush dotColorBarOnly, bool useHTF1, bool useHTF2, bool useHTF3, bool useHTF4, int x2Trend, int x2BrickSize, int x3Trend, int x3BrickSize, int x4Trend, int x4BrickSize, int x5Trend, int x5BrickSize)
		{
			return SniperTrend(Input, wMAHighValue, wMALowValue, dotColorBarandCloud, dotColorBarOnly, useHTF1, useHTF2, useHTF3, useHTF4, x2Trend, x2BrickSize, x3Trend, x3BrickSize, x4Trend, x4BrickSize, x5Trend, x5BrickSize);
		}

		public SniperIndicators.SniperVAD SniperVAD(int kLabelTrigger, int textPixelShift, SimpleFont myFont)
		{
			return SniperVAD(Input, kLabelTrigger, textPixelShift, myFont);
		}

		public SniperIndicators.SniperVol SniperVol(int volumeEmaAve, double dwWideSpread, double dwNarrowSpread, double dwHighClose, double dwLowClose, double dwUltraHighVol, double dwAboveAvgVol, bool banners, bool alertss, Brush bandAreaColor, bool colorBarToTrend, double bandAreaColorOpacity)
		{
			return SniperVol(Input, volumeEmaAve, dwWideSpread, dwNarrowSpread, dwHighClose, dwLowClose, dwUltraHighVol, dwAboveAvgVol, banners, alertss, bandAreaColor, colorBarToTrend, bandAreaColorOpacity);
		}

		public SniperIndicators.SniperVolatility SniperVolatility(int aDXPeriod, int upperLevel, int lowerLevel)
		{
			return SniperVolatility(Input, aDXPeriod, upperLevel, lowerLevel);
		}

		public VWAP81978 VWAP81978()
		{
			return VWAP81978(Input);
		}

		public MACrossBuilder1978 MACrossBuilder1978(CDMAtype1978 ma0Type, PriceType fastPriceType, int fastMAPeriod, CDMAtype1978 ma1Type, PriceType slowPriceType, int slowMAPeriod, int crossLookBack, bool showCrossAbove, bool showCrossBelow)
		{
			return MACrossBuilder1978(Input, ma0Type, fastPriceType, fastMAPeriod, ma1Type, slowPriceType, slowMAPeriod, crossLookBack, showCrossAbove, showCrossBelow);
		}

		public MovingAverageRibbon_Color1978 MovingAverageRibbon_Color1978(RibbonMAType1978 movingAverage, int basePeriod, int incrementalPeriod, Brush upColor, Brush downColor)
		{
			return MovingAverageRibbon_Color1978(Input, movingAverage, basePeriod, incrementalPeriod, upColor, downColor);
		}

		public Wilder1978 Wilder1978(int period)
		{
			return Wilder1978(Input, period);
		}

		public LinRegSlopeSFX1978 LinRegSlopeSFX1978(int period, bool exponential, int returnval)
		{
			return LinRegSlopeSFX1978(Input, period, exponential, returnval);
		}

		public EMASlopeColor EMASlopeColor(int period, Brush upColor, Brush dnColor, bool colorSlope)
		{
			return EMASlopeColor(Input, period, upColor, dnColor, colorSlope);
		}


		
		public SniperIndicators.SniperBand SniperBand(ISeries<double> input, CDMAtype2 ma0Type, PriceType fastPriceType, int fastMAPeriod, CDMAtype2 ma1Type, PriceType slowPriceType, int slowMAPeriod, int crossLookBack, bool showCrossAbove, bool showCrossBelow)
		{
			if (cacheSniperBand != null)
				for (int idx = 0; idx < cacheSniperBand.Length; idx++)
					if (cacheSniperBand[idx].Ma0Type == ma0Type && cacheSniperBand[idx].fastPriceType == fastPriceType && cacheSniperBand[idx].FastMAPeriod == fastMAPeriod && cacheSniperBand[idx].Ma1Type == ma1Type && cacheSniperBand[idx].slowPriceType == slowPriceType && cacheSniperBand[idx].SlowMAPeriod == slowMAPeriod && cacheSniperBand[idx].CrossLookBack == crossLookBack && cacheSniperBand[idx].ShowCrossAbove == showCrossAbove && cacheSniperBand[idx].ShowCrossBelow == showCrossBelow && cacheSniperBand[idx].EqualsInput(input))
						return cacheSniperBand[idx];
			return CacheIndicator<SniperIndicators.SniperBand>(new SniperIndicators.SniperBand(){ Ma0Type = ma0Type, fastPriceType = fastPriceType, FastMAPeriod = fastMAPeriod, Ma1Type = ma1Type, slowPriceType = slowPriceType, SlowMAPeriod = slowMAPeriod, CrossLookBack = crossLookBack, ShowCrossAbove = showCrossAbove, ShowCrossBelow = showCrossBelow }, input, ref cacheSniperBand);
		}

		public SniperIndicators.SniperDivergenceOBOS SniperDivergenceOBOS(ISeries<double> input)
		{
			if (cacheSniperDivergenceOBOS != null)
				for (int idx = 0; idx < cacheSniperDivergenceOBOS.Length; idx++)
					if ( cacheSniperDivergenceOBOS[idx].EqualsInput(input))
						return cacheSniperDivergenceOBOS[idx];
			return CacheIndicator<SniperIndicators.SniperDivergenceOBOS>(new SniperIndicators.SniperDivergenceOBOS(), input, ref cacheSniperDivergenceOBOS);
		}

		public SniperIndicators.SniperEMABand SniperEMABand(ISeries<double> input, bool eMASmall, bool eMABig)
		{
			if (cacheSniperEMABand != null)
				for (int idx = 0; idx < cacheSniperEMABand.Length; idx++)
					if (cacheSniperEMABand[idx].EMASmall == eMASmall && cacheSniperEMABand[idx].EMABig == eMABig && cacheSniperEMABand[idx].EqualsInput(input))
						return cacheSniperEMABand[idx];
			return CacheIndicator<SniperIndicators.SniperEMABand>(new SniperIndicators.SniperEMABand(){ EMASmall = eMASmall, EMABig = eMABig }, input, ref cacheSniperEMABand);
		}

		public SniperIndicators.SniperExplosion SniperExplosion(ISeries<double> input, int fastma, int slowma)
		{
			if (cacheSniperExplosion != null)
				for (int idx = 0; idx < cacheSniperExplosion.Length; idx++)
					if (cacheSniperExplosion[idx].Fastma == fastma && cacheSniperExplosion[idx].Slowma == slowma && cacheSniperExplosion[idx].EqualsInput(input))
						return cacheSniperExplosion[idx];
			return CacheIndicator<SniperIndicators.SniperExplosion>(new SniperIndicators.SniperExplosion(){ Fastma = fastma, Slowma = slowma }, input, ref cacheSniperExplosion);
		}

		public SniperIndicators.SniperMultipleLevel SniperMultipleLevel(ISeries<double> input, Brush premarketRegionColor, int premarketRegionOpacity, Brush initialBalanceRegionColor, int initialBalanceRegionOpacity)
		{
			if (cacheSniperMultipleLevel != null)
				for (int idx = 0; idx < cacheSniperMultipleLevel.Length; idx++)
					if (cacheSniperMultipleLevel[idx].PremarketRegionColor == premarketRegionColor && cacheSniperMultipleLevel[idx].PremarketRegionOpacity == premarketRegionOpacity && cacheSniperMultipleLevel[idx].InitialBalanceRegionColor == initialBalanceRegionColor && cacheSniperMultipleLevel[idx].InitialBalanceRegionOpacity == initialBalanceRegionOpacity && cacheSniperMultipleLevel[idx].EqualsInput(input))
						return cacheSniperMultipleLevel[idx];
			return CacheIndicator<SniperIndicators.SniperMultipleLevel>(new SniperIndicators.SniperMultipleLevel(){ PremarketRegionColor = premarketRegionColor, PremarketRegionOpacity = premarketRegionOpacity, InitialBalanceRegionColor = initialBalanceRegionColor, InitialBalanceRegionOpacity = initialBalanceRegionOpacity }, input, ref cacheSniperMultipleLevel);
		}

		public SniperIndicators.SniperSuperTrend SniperSuperTrend(ISeries<double> input, Brush fiveTenLong, Brush fiveTenShort, Brush currentRainbowShort, Brush currentRainbowLong, Brush allThreeLong, Brush allThreeShort)
		{
			if (cacheSniperSuperTrend != null)
				for (int idx = 0; idx < cacheSniperSuperTrend.Length; idx++)
					if (cacheSniperSuperTrend[idx].FiveTenLong == fiveTenLong && cacheSniperSuperTrend[idx].FiveTenShort == fiveTenShort && cacheSniperSuperTrend[idx].CurrentRainbowShort == currentRainbowShort && cacheSniperSuperTrend[idx].CurrentRainbowLong == currentRainbowLong && cacheSniperSuperTrend[idx].AllThreeLong == allThreeLong && cacheSniperSuperTrend[idx].AllThreeShort == allThreeShort && cacheSniperSuperTrend[idx].EqualsInput(input))
						return cacheSniperSuperTrend[idx];
			return CacheIndicator<SniperIndicators.SniperSuperTrend>(new SniperIndicators.SniperSuperTrend(){ FiveTenLong = fiveTenLong, FiveTenShort = fiveTenShort, CurrentRainbowShort = currentRainbowShort, CurrentRainbowLong = currentRainbowLong, AllThreeLong = allThreeLong, AllThreeShort = allThreeShort }, input, ref cacheSniperSuperTrend);
		}

		public SniperIndicators.SniperTrend SniperTrend(ISeries<double> input, int wMAHighValue, int wMALowValue, Brush dotColorBarandCloud, Brush dotColorBarOnly, bool useHTF1, bool useHTF2, bool useHTF3, bool useHTF4, int x2Trend, int x2BrickSize, int x3Trend, int x3BrickSize, int x4Trend, int x4BrickSize, int x5Trend, int x5BrickSize)
		{
			if (cacheSniperTrend != null)
				for (int idx = 0; idx < cacheSniperTrend.Length; idx++)
					if (cacheSniperTrend[idx].WMAHighValue == wMAHighValue && cacheSniperTrend[idx].WMALowValue == wMALowValue && cacheSniperTrend[idx].DotColorBarandCloud == dotColorBarandCloud && cacheSniperTrend[idx].DotColorBarOnly == dotColorBarOnly && cacheSniperTrend[idx].UseHTF1 == useHTF1 && cacheSniperTrend[idx].UseHTF2 == useHTF2 && cacheSniperTrend[idx].UseHTF3 == useHTF3 && cacheSniperTrend[idx].UseHTF4 == useHTF4 && cacheSniperTrend[idx].x2Trend == x2Trend && cacheSniperTrend[idx].x2BrickSize == x2BrickSize && cacheSniperTrend[idx].x3Trend == x3Trend && cacheSniperTrend[idx].x3BrickSize == x3BrickSize && cacheSniperTrend[idx].x4Trend == x4Trend && cacheSniperTrend[idx].x4BrickSize == x4BrickSize && cacheSniperTrend[idx].x5Trend == x5Trend && cacheSniperTrend[idx].x5BrickSize == x5BrickSize && cacheSniperTrend[idx].EqualsInput(input))
						return cacheSniperTrend[idx];
			return CacheIndicator<SniperIndicators.SniperTrend>(new SniperIndicators.SniperTrend(){ WMAHighValue = wMAHighValue, WMALowValue = wMALowValue, DotColorBarandCloud = dotColorBarandCloud, DotColorBarOnly = dotColorBarOnly, UseHTF1 = useHTF1, UseHTF2 = useHTF2, UseHTF3 = useHTF3, UseHTF4 = useHTF4, x2Trend = x2Trend, x2BrickSize = x2BrickSize, x3Trend = x3Trend, x3BrickSize = x3BrickSize, x4Trend = x4Trend, x4BrickSize = x4BrickSize, x5Trend = x5Trend, x5BrickSize = x5BrickSize }, input, ref cacheSniperTrend);
		}

		public SniperIndicators.SniperVAD SniperVAD(ISeries<double> input, int kLabelTrigger, int textPixelShift, SimpleFont myFont)
		{
			if (cacheSniperVAD != null)
				for (int idx = 0; idx < cacheSniperVAD.Length; idx++)
					if (cacheSniperVAD[idx].KLabelTrigger == kLabelTrigger && cacheSniperVAD[idx].TextPixelShift == textPixelShift && cacheSniperVAD[idx].myFont == myFont && cacheSniperVAD[idx].EqualsInput(input))
						return cacheSniperVAD[idx];
			return CacheIndicator<SniperIndicators.SniperVAD>(new SniperIndicators.SniperVAD(){ KLabelTrigger = kLabelTrigger, TextPixelShift = textPixelShift, myFont = myFont }, input, ref cacheSniperVAD);
		}

		public SniperIndicators.SniperVol SniperVol(ISeries<double> input, int volumeEmaAve, double dwWideSpread, double dwNarrowSpread, double dwHighClose, double dwLowClose, double dwUltraHighVol, double dwAboveAvgVol, bool banners, bool alertss, Brush bandAreaColor, bool colorBarToTrend, double bandAreaColorOpacity)
		{
			if (cacheSniperVol != null)
				for (int idx = 0; idx < cacheSniperVol.Length; idx++)
					if (cacheSniperVol[idx].VolumeEmaAve == volumeEmaAve && cacheSniperVol[idx].DwWideSpread == dwWideSpread && cacheSniperVol[idx].DwNarrowSpread == dwNarrowSpread && cacheSniperVol[idx].DwHighClose == dwHighClose && cacheSniperVol[idx].DwLowClose == dwLowClose && cacheSniperVol[idx].DwUltraHighVol == dwUltraHighVol && cacheSniperVol[idx].DwAboveAvgVol == dwAboveAvgVol && cacheSniperVol[idx].Banners == banners && cacheSniperVol[idx].Alertss == alertss && cacheSniperVol[idx].BandAreaColor == bandAreaColor && cacheSniperVol[idx].ColorBarToTrend == colorBarToTrend && cacheSniperVol[idx].BandAreaColorOpacity == bandAreaColorOpacity && cacheSniperVol[idx].EqualsInput(input))
						return cacheSniperVol[idx];
			return CacheIndicator<SniperIndicators.SniperVol>(new SniperIndicators.SniperVol(){ VolumeEmaAve = volumeEmaAve, DwWideSpread = dwWideSpread, DwNarrowSpread = dwNarrowSpread, DwHighClose = dwHighClose, DwLowClose = dwLowClose, DwUltraHighVol = dwUltraHighVol, DwAboveAvgVol = dwAboveAvgVol, Banners = banners, Alertss = alertss, BandAreaColor = bandAreaColor, ColorBarToTrend = colorBarToTrend, BandAreaColorOpacity = bandAreaColorOpacity }, input, ref cacheSniperVol);
		}

		public SniperIndicators.SniperVolatility SniperVolatility(ISeries<double> input, int aDXPeriod, int upperLevel, int lowerLevel)
		{
			if (cacheSniperVolatility != null)
				for (int idx = 0; idx < cacheSniperVolatility.Length; idx++)
					if (cacheSniperVolatility[idx].ADXPeriod == aDXPeriod && cacheSniperVolatility[idx].UpperLevel == upperLevel && cacheSniperVolatility[idx].LowerLevel == lowerLevel && cacheSniperVolatility[idx].EqualsInput(input))
						return cacheSniperVolatility[idx];
			return CacheIndicator<SniperIndicators.SniperVolatility>(new SniperIndicators.SniperVolatility(){ ADXPeriod = aDXPeriod, UpperLevel = upperLevel, LowerLevel = lowerLevel }, input, ref cacheSniperVolatility);
		}

		public VWAP81978 VWAP81978(ISeries<double> input)
		{
			if (cacheVWAP81978 != null)
				for (int idx = 0; idx < cacheVWAP81978.Length; idx++)
					if ( cacheVWAP81978[idx].EqualsInput(input))
						return cacheVWAP81978[idx];
			return CacheIndicator<VWAP81978>(new VWAP81978(), input, ref cacheVWAP81978);
		}

		public MACrossBuilder1978 MACrossBuilder1978(ISeries<double> input, CDMAtype1978 ma0Type, PriceType fastPriceType, int fastMAPeriod, CDMAtype1978 ma1Type, PriceType slowPriceType, int slowMAPeriod, int crossLookBack, bool showCrossAbove, bool showCrossBelow)
		{
			if (cacheMACrossBuilder1978 != null)
				for (int idx = 0; idx < cacheMACrossBuilder1978.Length; idx++)
					if (cacheMACrossBuilder1978[idx].Ma0Type == ma0Type && cacheMACrossBuilder1978[idx].fastPriceType == fastPriceType && cacheMACrossBuilder1978[idx].FastMAPeriod == fastMAPeriod && cacheMACrossBuilder1978[idx].Ma1Type == ma1Type && cacheMACrossBuilder1978[idx].slowPriceType == slowPriceType && cacheMACrossBuilder1978[idx].SlowMAPeriod == slowMAPeriod && cacheMACrossBuilder1978[idx].CrossLookBack == crossLookBack && cacheMACrossBuilder1978[idx].ShowCrossAbove == showCrossAbove && cacheMACrossBuilder1978[idx].ShowCrossBelow == showCrossBelow && cacheMACrossBuilder1978[idx].EqualsInput(input))
						return cacheMACrossBuilder1978[idx];
			return CacheIndicator<MACrossBuilder1978>(new MACrossBuilder1978(){ Ma0Type = ma0Type, fastPriceType = fastPriceType, FastMAPeriod = fastMAPeriod, Ma1Type = ma1Type, slowPriceType = slowPriceType, SlowMAPeriod = slowMAPeriod, CrossLookBack = crossLookBack, ShowCrossAbove = showCrossAbove, ShowCrossBelow = showCrossBelow }, input, ref cacheMACrossBuilder1978);
		}

		public MovingAverageRibbon_Color1978 MovingAverageRibbon_Color1978(ISeries<double> input, RibbonMAType1978 movingAverage, int basePeriod, int incrementalPeriod, Brush upColor, Brush downColor)
		{
			if (cacheMovingAverageRibbon_Color1978 != null)
				for (int idx = 0; idx < cacheMovingAverageRibbon_Color1978.Length; idx++)
					if (cacheMovingAverageRibbon_Color1978[idx].MovingAverage == movingAverage && cacheMovingAverageRibbon_Color1978[idx].BasePeriod == basePeriod && cacheMovingAverageRibbon_Color1978[idx].IncrementalPeriod == incrementalPeriod && cacheMovingAverageRibbon_Color1978[idx].UpColor == upColor && cacheMovingAverageRibbon_Color1978[idx].DownColor == downColor && cacheMovingAverageRibbon_Color1978[idx].EqualsInput(input))
						return cacheMovingAverageRibbon_Color1978[idx];
			return CacheIndicator<MovingAverageRibbon_Color1978>(new MovingAverageRibbon_Color1978(){ MovingAverage = movingAverage, BasePeriod = basePeriod, IncrementalPeriod = incrementalPeriod, UpColor = upColor, DownColor = downColor }, input, ref cacheMovingAverageRibbon_Color1978);
		}

		public Wilder1978 Wilder1978(ISeries<double> input, int period)
		{
			if (cacheWilder1978 != null)
				for (int idx = 0; idx < cacheWilder1978.Length; idx++)
					if (cacheWilder1978[idx].Period == period && cacheWilder1978[idx].EqualsInput(input))
						return cacheWilder1978[idx];
			return CacheIndicator<Wilder1978>(new Wilder1978(){ Period = period }, input, ref cacheWilder1978);
		}

		public LinRegSlopeSFX1978 LinRegSlopeSFX1978(ISeries<double> input, int period, bool exponential, int returnval)
		{
			if (cacheLinRegSlopeSFX1978 != null)
				for (int idx = 0; idx < cacheLinRegSlopeSFX1978.Length; idx++)
					if (cacheLinRegSlopeSFX1978[idx].Period == period && cacheLinRegSlopeSFX1978[idx].Exponential == exponential && cacheLinRegSlopeSFX1978[idx].Returnval == returnval && cacheLinRegSlopeSFX1978[idx].EqualsInput(input))
						return cacheLinRegSlopeSFX1978[idx];
			return CacheIndicator<LinRegSlopeSFX1978>(new LinRegSlopeSFX1978(){ Period = period, Exponential = exponential, Returnval = returnval }, input, ref cacheLinRegSlopeSFX1978);
		}

		public EMASlopeColor EMASlopeColor(ISeries<double> input, int period, Brush upColor, Brush dnColor, bool colorSlope)
		{
			if (cacheEMASlopeColor != null)
				for (int idx = 0; idx < cacheEMASlopeColor.Length; idx++)
					if (cacheEMASlopeColor[idx].Period == period && cacheEMASlopeColor[idx].UpColor == upColor && cacheEMASlopeColor[idx].DnColor == dnColor && cacheEMASlopeColor[idx].ColorSlope == colorSlope && cacheEMASlopeColor[idx].EqualsInput(input))
						return cacheEMASlopeColor[idx];
			return CacheIndicator<EMASlopeColor>(new EMASlopeColor(){ Period = period, UpColor = upColor, DnColor = dnColor, ColorSlope = colorSlope }, input, ref cacheEMASlopeColor);
		}

	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		
		public Indicators.SniperIndicators.SniperBand SniperBand(CDMAtype2 ma0Type, PriceType fastPriceType, int fastMAPeriod, CDMAtype2 ma1Type, PriceType slowPriceType, int slowMAPeriod, int crossLookBack, bool showCrossAbove, bool showCrossBelow)
		{
			return indicator.SniperBand(Input, ma0Type, fastPriceType, fastMAPeriod, ma1Type, slowPriceType, slowMAPeriod, crossLookBack, showCrossAbove, showCrossBelow);
		}

		public Indicators.SniperIndicators.SniperDivergenceOBOS SniperDivergenceOBOS()
		{
			return indicator.SniperDivergenceOBOS(Input);
		}

		public Indicators.SniperIndicators.SniperEMABand SniperEMABand(bool eMASmall, bool eMABig)
		{
			return indicator.SniperEMABand(Input, eMASmall, eMABig);
		}

		public Indicators.SniperIndicators.SniperExplosion SniperExplosion(int fastma, int slowma)
		{
			return indicator.SniperExplosion(Input, fastma, slowma);
		}

		public Indicators.SniperIndicators.SniperMultipleLevel SniperMultipleLevel(Brush premarketRegionColor, int premarketRegionOpacity, Brush initialBalanceRegionColor, int initialBalanceRegionOpacity)
		{
			return indicator.SniperMultipleLevel(Input, premarketRegionColor, premarketRegionOpacity, initialBalanceRegionColor, initialBalanceRegionOpacity);
		}

		public Indicators.SniperIndicators.SniperSuperTrend SniperSuperTrend(Brush fiveTenLong, Brush fiveTenShort, Brush currentRainbowShort, Brush currentRainbowLong, Brush allThreeLong, Brush allThreeShort)
		{
			return indicator.SniperSuperTrend(Input, fiveTenLong, fiveTenShort, currentRainbowShort, currentRainbowLong, allThreeLong, allThreeShort);
		}

		public Indicators.SniperIndicators.SniperTrend SniperTrend(int wMAHighValue, int wMALowValue, Brush dotColorBarandCloud, Brush dotColorBarOnly, bool useHTF1, bool useHTF2, bool useHTF3, bool useHTF4, int x2Trend, int x2BrickSize, int x3Trend, int x3BrickSize, int x4Trend, int x4BrickSize, int x5Trend, int x5BrickSize)
		{
			return indicator.SniperTrend(Input, wMAHighValue, wMALowValue, dotColorBarandCloud, dotColorBarOnly, useHTF1, useHTF2, useHTF3, useHTF4, x2Trend, x2BrickSize, x3Trend, x3BrickSize, x4Trend, x4BrickSize, x5Trend, x5BrickSize);
		}

		public Indicators.SniperIndicators.SniperVAD SniperVAD(int kLabelTrigger, int textPixelShift, SimpleFont myFont)
		{
			return indicator.SniperVAD(Input, kLabelTrigger, textPixelShift, myFont);
		}

		public Indicators.SniperIndicators.SniperVol SniperVol(int volumeEmaAve, double dwWideSpread, double dwNarrowSpread, double dwHighClose, double dwLowClose, double dwUltraHighVol, double dwAboveAvgVol, bool banners, bool alertss, Brush bandAreaColor, bool colorBarToTrend, double bandAreaColorOpacity)
		{
			return indicator.SniperVol(Input, volumeEmaAve, dwWideSpread, dwNarrowSpread, dwHighClose, dwLowClose, dwUltraHighVol, dwAboveAvgVol, banners, alertss, bandAreaColor, colorBarToTrend, bandAreaColorOpacity);
		}

		public Indicators.SniperIndicators.SniperVolatility SniperVolatility(int aDXPeriod, int upperLevel, int lowerLevel)
		{
			return indicator.SniperVolatility(Input, aDXPeriod, upperLevel, lowerLevel);
		}

		public Indicators.VWAP81978 VWAP81978()
		{
			return indicator.VWAP81978(Input);
		}

		public Indicators.MACrossBuilder1978 MACrossBuilder1978(CDMAtype1978 ma0Type, PriceType fastPriceType, int fastMAPeriod, CDMAtype1978 ma1Type, PriceType slowPriceType, int slowMAPeriod, int crossLookBack, bool showCrossAbove, bool showCrossBelow)
		{
			return indicator.MACrossBuilder1978(Input, ma0Type, fastPriceType, fastMAPeriod, ma1Type, slowPriceType, slowMAPeriod, crossLookBack, showCrossAbove, showCrossBelow);
		}

		public Indicators.MovingAverageRibbon_Color1978 MovingAverageRibbon_Color1978(RibbonMAType1978 movingAverage, int basePeriod, int incrementalPeriod, Brush upColor, Brush downColor)
		{
			return indicator.MovingAverageRibbon_Color1978(Input, movingAverage, basePeriod, incrementalPeriod, upColor, downColor);
		}

		public Indicators.Wilder1978 Wilder1978(int period)
		{
			return indicator.Wilder1978(Input, period);
		}

		public Indicators.LinRegSlopeSFX1978 LinRegSlopeSFX1978(int period, bool exponential, int returnval)
		{
			return indicator.LinRegSlopeSFX1978(Input, period, exponential, returnval);
		}

		public Indicators.EMASlopeColor EMASlopeColor(int period, Brush upColor, Brush dnColor, bool colorSlope)
		{
			return indicator.EMASlopeColor(Input, period, upColor, dnColor, colorSlope);
		}


		
		public Indicators.SniperIndicators.SniperBand SniperBand(ISeries<double> input , CDMAtype2 ma0Type, PriceType fastPriceType, int fastMAPeriod, CDMAtype2 ma1Type, PriceType slowPriceType, int slowMAPeriod, int crossLookBack, bool showCrossAbove, bool showCrossBelow)
		{
			return indicator.SniperBand(input, ma0Type, fastPriceType, fastMAPeriod, ma1Type, slowPriceType, slowMAPeriod, crossLookBack, showCrossAbove, showCrossBelow);
		}

		public Indicators.SniperIndicators.SniperDivergenceOBOS SniperDivergenceOBOS(ISeries<double> input )
		{
			return indicator.SniperDivergenceOBOS(input);
		}

		public Indicators.SniperIndicators.SniperEMABand SniperEMABand(ISeries<double> input , bool eMASmall, bool eMABig)
		{
			return indicator.SniperEMABand(input, eMASmall, eMABig);
		}

		public Indicators.SniperIndicators.SniperExplosion SniperExplosion(ISeries<double> input , int fastma, int slowma)
		{
			return indicator.SniperExplosion(input, fastma, slowma);
		}

		public Indicators.SniperIndicators.SniperMultipleLevel SniperMultipleLevel(ISeries<double> input , Brush premarketRegionColor, int premarketRegionOpacity, Brush initialBalanceRegionColor, int initialBalanceRegionOpacity)
		{
			return indicator.SniperMultipleLevel(input, premarketRegionColor, premarketRegionOpacity, initialBalanceRegionColor, initialBalanceRegionOpacity);
		}

		public Indicators.SniperIndicators.SniperSuperTrend SniperSuperTrend(ISeries<double> input , Brush fiveTenLong, Brush fiveTenShort, Brush currentRainbowShort, Brush currentRainbowLong, Brush allThreeLong, Brush allThreeShort)
		{
			return indicator.SniperSuperTrend(input, fiveTenLong, fiveTenShort, currentRainbowShort, currentRainbowLong, allThreeLong, allThreeShort);
		}

		public Indicators.SniperIndicators.SniperTrend SniperTrend(ISeries<double> input , int wMAHighValue, int wMALowValue, Brush dotColorBarandCloud, Brush dotColorBarOnly, bool useHTF1, bool useHTF2, bool useHTF3, bool useHTF4, int x2Trend, int x2BrickSize, int x3Trend, int x3BrickSize, int x4Trend, int x4BrickSize, int x5Trend, int x5BrickSize)
		{
			return indicator.SniperTrend(input, wMAHighValue, wMALowValue, dotColorBarandCloud, dotColorBarOnly, useHTF1, useHTF2, useHTF3, useHTF4, x2Trend, x2BrickSize, x3Trend, x3BrickSize, x4Trend, x4BrickSize, x5Trend, x5BrickSize);
		}

		public Indicators.SniperIndicators.SniperVAD SniperVAD(ISeries<double> input , int kLabelTrigger, int textPixelShift, SimpleFont myFont)
		{
			return indicator.SniperVAD(input, kLabelTrigger, textPixelShift, myFont);
		}

		public Indicators.SniperIndicators.SniperVol SniperVol(ISeries<double> input , int volumeEmaAve, double dwWideSpread, double dwNarrowSpread, double dwHighClose, double dwLowClose, double dwUltraHighVol, double dwAboveAvgVol, bool banners, bool alertss, Brush bandAreaColor, bool colorBarToTrend, double bandAreaColorOpacity)
		{
			return indicator.SniperVol(input, volumeEmaAve, dwWideSpread, dwNarrowSpread, dwHighClose, dwLowClose, dwUltraHighVol, dwAboveAvgVol, banners, alertss, bandAreaColor, colorBarToTrend, bandAreaColorOpacity);
		}

		public Indicators.SniperIndicators.SniperVolatility SniperVolatility(ISeries<double> input , int aDXPeriod, int upperLevel, int lowerLevel)
		{
			return indicator.SniperVolatility(input, aDXPeriod, upperLevel, lowerLevel);
		}

		public Indicators.VWAP81978 VWAP81978(ISeries<double> input )
		{
			return indicator.VWAP81978(input);
		}

		public Indicators.MACrossBuilder1978 MACrossBuilder1978(ISeries<double> input , CDMAtype1978 ma0Type, PriceType fastPriceType, int fastMAPeriod, CDMAtype1978 ma1Type, PriceType slowPriceType, int slowMAPeriod, int crossLookBack, bool showCrossAbove, bool showCrossBelow)
		{
			return indicator.MACrossBuilder1978(input, ma0Type, fastPriceType, fastMAPeriod, ma1Type, slowPriceType, slowMAPeriod, crossLookBack, showCrossAbove, showCrossBelow);
		}

		public Indicators.MovingAverageRibbon_Color1978 MovingAverageRibbon_Color1978(ISeries<double> input , RibbonMAType1978 movingAverage, int basePeriod, int incrementalPeriod, Brush upColor, Brush downColor)
		{
			return indicator.MovingAverageRibbon_Color1978(input, movingAverage, basePeriod, incrementalPeriod, upColor, downColor);
		}

		public Indicators.Wilder1978 Wilder1978(ISeries<double> input , int period)
		{
			return indicator.Wilder1978(input, period);
		}

		public Indicators.LinRegSlopeSFX1978 LinRegSlopeSFX1978(ISeries<double> input , int period, bool exponential, int returnval)
		{
			return indicator.LinRegSlopeSFX1978(input, period, exponential, returnval);
		}

		public Indicators.EMASlopeColor EMASlopeColor(ISeries<double> input , int period, Brush upColor, Brush dnColor, bool colorSlope)
		{
			return indicator.EMASlopeColor(input, period, upColor, dnColor, colorSlope);
		}
	
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		
		public Indicators.SniperIndicators.SniperBand SniperBand(CDMAtype2 ma0Type, PriceType fastPriceType, int fastMAPeriod, CDMAtype2 ma1Type, PriceType slowPriceType, int slowMAPeriod, int crossLookBack, bool showCrossAbove, bool showCrossBelow)
		{
			return indicator.SniperBand(Input, ma0Type, fastPriceType, fastMAPeriod, ma1Type, slowPriceType, slowMAPeriod, crossLookBack, showCrossAbove, showCrossBelow);
		}

		public Indicators.SniperIndicators.SniperDivergenceOBOS SniperDivergenceOBOS()
		{
			return indicator.SniperDivergenceOBOS(Input);
		}

		public Indicators.SniperIndicators.SniperEMABand SniperEMABand(bool eMASmall, bool eMABig)
		{
			return indicator.SniperEMABand(Input, eMASmall, eMABig);
		}

		public Indicators.SniperIndicators.SniperExplosion SniperExplosion(int fastma, int slowma)
		{
			return indicator.SniperExplosion(Input, fastma, slowma);
		}

		public Indicators.SniperIndicators.SniperMultipleLevel SniperMultipleLevel(Brush premarketRegionColor, int premarketRegionOpacity, Brush initialBalanceRegionColor, int initialBalanceRegionOpacity)
		{
			return indicator.SniperMultipleLevel(Input, premarketRegionColor, premarketRegionOpacity, initialBalanceRegionColor, initialBalanceRegionOpacity);
		}

		public Indicators.SniperIndicators.SniperSuperTrend SniperSuperTrend(Brush fiveTenLong, Brush fiveTenShort, Brush currentRainbowShort, Brush currentRainbowLong, Brush allThreeLong, Brush allThreeShort)
		{
			return indicator.SniperSuperTrend(Input, fiveTenLong, fiveTenShort, currentRainbowShort, currentRainbowLong, allThreeLong, allThreeShort);
		}

		public Indicators.SniperIndicators.SniperTrend SniperTrend(int wMAHighValue, int wMALowValue, Brush dotColorBarandCloud, Brush dotColorBarOnly, bool useHTF1, bool useHTF2, bool useHTF3, bool useHTF4, int x2Trend, int x2BrickSize, int x3Trend, int x3BrickSize, int x4Trend, int x4BrickSize, int x5Trend, int x5BrickSize)
		{
			return indicator.SniperTrend(Input, wMAHighValue, wMALowValue, dotColorBarandCloud, dotColorBarOnly, useHTF1, useHTF2, useHTF3, useHTF4, x2Trend, x2BrickSize, x3Trend, x3BrickSize, x4Trend, x4BrickSize, x5Trend, x5BrickSize);
		}

		public Indicators.SniperIndicators.SniperVAD SniperVAD(int kLabelTrigger, int textPixelShift, SimpleFont myFont)
		{
			return indicator.SniperVAD(Input, kLabelTrigger, textPixelShift, myFont);
		}

		public Indicators.SniperIndicators.SniperVol SniperVol(int volumeEmaAve, double dwWideSpread, double dwNarrowSpread, double dwHighClose, double dwLowClose, double dwUltraHighVol, double dwAboveAvgVol, bool banners, bool alertss, Brush bandAreaColor, bool colorBarToTrend, double bandAreaColorOpacity)
		{
			return indicator.SniperVol(Input, volumeEmaAve, dwWideSpread, dwNarrowSpread, dwHighClose, dwLowClose, dwUltraHighVol, dwAboveAvgVol, banners, alertss, bandAreaColor, colorBarToTrend, bandAreaColorOpacity);
		}

		public Indicators.SniperIndicators.SniperVolatility SniperVolatility(int aDXPeriod, int upperLevel, int lowerLevel)
		{
			return indicator.SniperVolatility(Input, aDXPeriod, upperLevel, lowerLevel);
		}

		public Indicators.VWAP81978 VWAP81978()
		{
			return indicator.VWAP81978(Input);
		}

		public Indicators.MACrossBuilder1978 MACrossBuilder1978(CDMAtype1978 ma0Type, PriceType fastPriceType, int fastMAPeriod, CDMAtype1978 ma1Type, PriceType slowPriceType, int slowMAPeriod, int crossLookBack, bool showCrossAbove, bool showCrossBelow)
		{
			return indicator.MACrossBuilder1978(Input, ma0Type, fastPriceType, fastMAPeriod, ma1Type, slowPriceType, slowMAPeriod, crossLookBack, showCrossAbove, showCrossBelow);
		}

		public Indicators.MovingAverageRibbon_Color1978 MovingAverageRibbon_Color1978(RibbonMAType1978 movingAverage, int basePeriod, int incrementalPeriod, Brush upColor, Brush downColor)
		{
			return indicator.MovingAverageRibbon_Color1978(Input, movingAverage, basePeriod, incrementalPeriod, upColor, downColor);
		}

		public Indicators.Wilder1978 Wilder1978(int period)
		{
			return indicator.Wilder1978(Input, period);
		}

		public Indicators.LinRegSlopeSFX1978 LinRegSlopeSFX1978(int period, bool exponential, int returnval)
		{
			return indicator.LinRegSlopeSFX1978(Input, period, exponential, returnval);
		}

		public Indicators.EMASlopeColor EMASlopeColor(int period, Brush upColor, Brush dnColor, bool colorSlope)
		{
			return indicator.EMASlopeColor(Input, period, upColor, dnColor, colorSlope);
		}


		
		public Indicators.SniperIndicators.SniperBand SniperBand(ISeries<double> input , CDMAtype2 ma0Type, PriceType fastPriceType, int fastMAPeriod, CDMAtype2 ma1Type, PriceType slowPriceType, int slowMAPeriod, int crossLookBack, bool showCrossAbove, bool showCrossBelow)
		{
			return indicator.SniperBand(input, ma0Type, fastPriceType, fastMAPeriod, ma1Type, slowPriceType, slowMAPeriod, crossLookBack, showCrossAbove, showCrossBelow);
		}

		public Indicators.SniperIndicators.SniperDivergenceOBOS SniperDivergenceOBOS(ISeries<double> input )
		{
			return indicator.SniperDivergenceOBOS(input);
		}

		public Indicators.SniperIndicators.SniperEMABand SniperEMABand(ISeries<double> input , bool eMASmall, bool eMABig)
		{
			return indicator.SniperEMABand(input, eMASmall, eMABig);
		}

		public Indicators.SniperIndicators.SniperExplosion SniperExplosion(ISeries<double> input , int fastma, int slowma)
		{
			return indicator.SniperExplosion(input, fastma, slowma);
		}

		public Indicators.SniperIndicators.SniperMultipleLevel SniperMultipleLevel(ISeries<double> input , Brush premarketRegionColor, int premarketRegionOpacity, Brush initialBalanceRegionColor, int initialBalanceRegionOpacity)
		{
			return indicator.SniperMultipleLevel(input, premarketRegionColor, premarketRegionOpacity, initialBalanceRegionColor, initialBalanceRegionOpacity);
		}

		public Indicators.SniperIndicators.SniperSuperTrend SniperSuperTrend(ISeries<double> input , Brush fiveTenLong, Brush fiveTenShort, Brush currentRainbowShort, Brush currentRainbowLong, Brush allThreeLong, Brush allThreeShort)
		{
			return indicator.SniperSuperTrend(input, fiveTenLong, fiveTenShort, currentRainbowShort, currentRainbowLong, allThreeLong, allThreeShort);
		}

		public Indicators.SniperIndicators.SniperTrend SniperTrend(ISeries<double> input , int wMAHighValue, int wMALowValue, Brush dotColorBarandCloud, Brush dotColorBarOnly, bool useHTF1, bool useHTF2, bool useHTF3, bool useHTF4, int x2Trend, int x2BrickSize, int x3Trend, int x3BrickSize, int x4Trend, int x4BrickSize, int x5Trend, int x5BrickSize)
		{
			return indicator.SniperTrend(input, wMAHighValue, wMALowValue, dotColorBarandCloud, dotColorBarOnly, useHTF1, useHTF2, useHTF3, useHTF4, x2Trend, x2BrickSize, x3Trend, x3BrickSize, x4Trend, x4BrickSize, x5Trend, x5BrickSize);
		}

		public Indicators.SniperIndicators.SniperVAD SniperVAD(ISeries<double> input , int kLabelTrigger, int textPixelShift, SimpleFont myFont)
		{
			return indicator.SniperVAD(input, kLabelTrigger, textPixelShift, myFont);
		}

		public Indicators.SniperIndicators.SniperVol SniperVol(ISeries<double> input , int volumeEmaAve, double dwWideSpread, double dwNarrowSpread, double dwHighClose, double dwLowClose, double dwUltraHighVol, double dwAboveAvgVol, bool banners, bool alertss, Brush bandAreaColor, bool colorBarToTrend, double bandAreaColorOpacity)
		{
			return indicator.SniperVol(input, volumeEmaAve, dwWideSpread, dwNarrowSpread, dwHighClose, dwLowClose, dwUltraHighVol, dwAboveAvgVol, banners, alertss, bandAreaColor, colorBarToTrend, bandAreaColorOpacity);
		}

		public Indicators.SniperIndicators.SniperVolatility SniperVolatility(ISeries<double> input , int aDXPeriod, int upperLevel, int lowerLevel)
		{
			return indicator.SniperVolatility(input, aDXPeriod, upperLevel, lowerLevel);
		}

		public Indicators.VWAP81978 VWAP81978(ISeries<double> input )
		{
			return indicator.VWAP81978(input);
		}

		public Indicators.MACrossBuilder1978 MACrossBuilder1978(ISeries<double> input , CDMAtype1978 ma0Type, PriceType fastPriceType, int fastMAPeriod, CDMAtype1978 ma1Type, PriceType slowPriceType, int slowMAPeriod, int crossLookBack, bool showCrossAbove, bool showCrossBelow)
		{
			return indicator.MACrossBuilder1978(input, ma0Type, fastPriceType, fastMAPeriod, ma1Type, slowPriceType, slowMAPeriod, crossLookBack, showCrossAbove, showCrossBelow);
		}

		public Indicators.MovingAverageRibbon_Color1978 MovingAverageRibbon_Color1978(ISeries<double> input , RibbonMAType1978 movingAverage, int basePeriod, int incrementalPeriod, Brush upColor, Brush downColor)
		{
			return indicator.MovingAverageRibbon_Color1978(input, movingAverage, basePeriod, incrementalPeriod, upColor, downColor);
		}

		public Indicators.Wilder1978 Wilder1978(ISeries<double> input , int period)
		{
			return indicator.Wilder1978(input, period);
		}

		public Indicators.LinRegSlopeSFX1978 LinRegSlopeSFX1978(ISeries<double> input , int period, bool exponential, int returnval)
		{
			return indicator.LinRegSlopeSFX1978(input, period, exponential, returnval);
		}

		public Indicators.EMASlopeColor EMASlopeColor(ISeries<double> input , int period, Brush upColor, Brush dnColor, bool colorSlope)
		{
			return indicator.EMASlopeColor(input, period, upColor, dnColor, colorSlope);
		}

	}
}

#endregion
